function DeviceManager(element, states, callback){
	var _self = this;
	
	this.deviceList = new Array();
	this.dlHeader = new Object();
}

DeviceManager.prototype.downloaderCallback = function(json) {
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	this.dlHeader = tempArray.shift();
    DEBUGLOG("DeviceManager.js[14]: return_code: " + this.dlHeader["return_code"]);

	this.deviceList.length = 0;

    if(this.dlHeader && this.dlHeader["return_code"] == "10") {
        ath.expire();
        return;
    }
    else if(this.dlHeader && this.dlHeader["return_code"] == "55") {
        ath.subExpired();
        return;
    }
    
	this.deviceList = this.deviceList.concat(tempArray);

    /**
     * If no device exists then add a dummy one
     */
    if(this.deviceList.length == 0) {
        var dummyDevice = new Array();
        dummyDevice['id'] = 0;
        dummyDevice['label'] = "Dummy Device";
        this.deviceList.push(dummyDevice);
    }
	
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
	sht.populateDeviceLists();
}

DeviceManager.prototype.indexForName = function(label){
	for(x=0;x<this.deviceList.length;x++){
		if(this.deviceList[x]["label"] == label)
			return x;
	}
	return -1;
}

DeviceManager.prototype.indexForID = function(id){
	for(x=0;x<this.deviceList.length;x++){
		if(this.deviceList[x]["id"] == id)
			return x;
	}
	return -1;
}

function DeviceListController(element, index, id){
	var _self = this;
	this.index = index;
	this.element = element;
	this.id = id;
	this.element.onSelect = function(){ _self.doSelect(); }
}

DeviceListController.prototype.doSelect = function() {
	sht.changeSeriesRecordDevice(this.index);
}

DeviceManager.prototype.updateData = function(userInitiated){
	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
		return;
	}
	dvDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kDevicesFeed);
	dvDownloader.fetchURL();
}	
