function MyGuideUpcoming(){
	this.isSelected = false;
	this.contentHeight = 0;
	this.height = parseInt(loadPref("myGuideUpcomingScrollPoint"), 10);	

	this.resizeorigin = 0;
	resizestart = 0;
	
	this.contentArray = Array();
	
	this.containers = new Array();
	
	this.inSearch = false;
	this.searchString = null;
	this.usingRestoredSearch = false;
	this.recentSearches = Array();
	this.recentSearchesMenu = Array();
	this.searchtimer = null;
	
	this.dlHeader = new Object();
}

MyGuideUpcoming.prototype.clear = function(){
	while(document.getElementById("myguideupcoming_content_inner_container").hasChildNodes())
		document.getElementById("myguideupcoming_content_inner_container").removeChild(document.getElementById("myguideupcoming_content_inner_container").firstChild);
		
	this.contentArray.length = 0;
	this.containers.length = 0;
	this.inSearch = false;
	this.searchString = null;
	this.contentHeight = 0;
	this.isSelected = false;
}

MyGuideUpcoming.prototype.setup = function(){
	var _self = this;
	document.getElementById("myguideupcoming_resize_control").onmousedown = function(event){ _self.beginresize((event)); }
	document.getElementById("my-guide-upcoming-controls-search").onsearch = function(){_self.searchPrelim()}
	document.getElementById("myguideupcoming_resize_control").ondblclick = function(event){ _self.resetHeight(); }
}

MyGuideUpcoming.prototype.searchPrelim = function(){
	if(this.searchtimer != null){
		clearInterval(this.searchtimer);
	}
	this.searchtimer = null;

	var _self = this;
	this.searchtimer = setInterval(function(){ _self.doSearch(); }, 600);
	sht.forceCloseSheets();
}

MyGuideUpcoming.prototype.endSearch = function(){
	if(!this.usingRestoredSearch)
		this.saveSearch();
	document.getElementById("my-guide-upcoming-controls-search").value = "";
	if(this.searchtimer)
		clearInterval(this.searchtimer);
	this.searchtimer = null;
	this.inSearch = false;
	this.searchString = null;
	this.resetDisplay();
}

MyGuideUpcoming.prototype.doSearch = function(){
	sht.forceCloseSheets();
	if(this.searchtimer)
		clearInterval(this.searchtimer)
	this.searchtimer = null;
	
	if(document.getElementById("my-guide-upcoming-controls-search").value.length == 0){
		this.inSearch = false;
		this.searchString = null;
		this.resetDisplay();
	} else {
		if(this.inSearch == false)
			this.inSearch = true;
	
		this.searchString = document.getElementById("my-guide-upcoming-controls-search").value;
		this.filterWithString(this.searchString)
	}
}

MyGuideUpcoming.prototype.resetDisplay = function(searchstring){
	var offset = 0;
	var visibledays = 0;
	var visibleshows = 0;
		
	for(x=0;x<this.containers.length;x++){
		var foundmatch = false;
		var frameOffset = 0;
		
		for(y=0;y<this.containers[x].shows.length;y++){
			this.containers[x].shows[y].container.style.display = "block";
			this.containers[x].shows[y].container.style.top = frameOffset + "px";
			frameOffset += 13;
			foundmatch = true;
			visibleshows++;
		}
		
		if(offset != 0)
			offset += 6;
		this.containers[x].header.style.top = offset + "px";
		offset += 18;
		offset += 6;
		this.containers[x].container.style.top = offset + "px";
		offset += frameOffset;
		this.containers[x].container.style.display = "block";
		this.containers[x].container.style.height = frameOffset + "px";
		this.containers[x].header.style.display = "block";
		visibledays++;
	}
	this.contentHeight = offset + 4;
	this.resize();
}

MyGuideUpcoming.prototype.focus = function(){
	for(x=0;x<this.containers.length;x++){
		this.containers[x].header.style.backgroundPosition = "0px 0px"
	}
}

MyGuideUpcoming.prototype.blur = function(){
	for(x=0;x<this.containers.length;x++){
		this.containers[x].header.style.backgroundPosition = "0px -18px"
	}
}

MyGuideUpcoming.prototype.filterWithString = function(searchstring){
    var tokenArray = smartSplit( " ", searchstring, false, "\"", true );
    var tokenArrayLength = tokenArray.length;

	var myguideupcomingNewHeight = 0;
	var visibledays = 0;
	var visibleshows = 0;
	var offset = 0;
		
	for(x=0;x<this.containers.length;x++){
        /**
         * Filter out items on hidden channels
         */
        if(this.containers[x]['channel_id'] && chm.isHidden(this.containers[x]['channel_id']))
            continue;

        var foundmatch = false;
        var frameOffset = 0;
        
        var found;
        for(y=0;y<this.containers[x].shows.length;y++){
			var found=false;
			var bNegative;
			var strToken;
			var nMatchingTokens;

	        if(tokenArrayLength > 0){
				nMatchingTokens = 0;
	            for(var i=0;i<tokenArrayLength;i++){
					strToken = tokenArray[i];
					bNegative = (strToken[0] == '-');
					var bMatchFound=false;
				
					// Starts with a -, strip it, we have flagged it as a -ve term
					if(bNegative)
						strToken = strToken.slice(1);
				
                    // If the token is one of our reserved words and there is nothing after the ':'
                    // then remove the ':' so it acts like a normal word. ie treat 'genre:' as 'genre'
                    // but once you type 'genre:foo' then do a genre search for 'foo'
                    if(strToken.toLowerCase() == "title:" 		||
                       strToken.toLowerCase() == "series:" 		||
                       strToken.toLowerCase() == "episode:" 	||
                       strToken.toLowerCase() == "desc:" 		||
                       strToken.toLowerCase() == "genre:" 		||
                       strToken.toLowerCase() == "actor:" 		||
                       strToken.toLowerCase() == "director:" 	||
                       strToken.toLowerCase() == "repeat:" 		||
                       strToken.toLowerCase() == "year:" 		||
                       strToken.toLowerCase() == "after:" 		||
                       strToken.toLowerCase() == "before:") {
                        strToken = strToken.slice(0,strToken.length -1);
                    }
                    
		            /**
		             * Title ( Series + Episode )
		             */
					// title:boys
					if(strToken.toLowerCase().indexOf("title:") == 0) {
						var strTokenEscaped = strToken.slice(6);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatchedSeries = matchRegex.test(this.containers[x].shows[y].showtitle);
						var bRegexMatchedEpisode = matchRegex.test(this.containers[x].shows[y].episodetitle);

						if((bNegative && (!bRegexMatchedSeries && !bRegexMatchedEpisode)) || (!bNegative && (bRegexMatchedSeries||bRegexMatchedEpisode))) {
							bMatchFound = true;
						}
					}

		            /**
		             * Title (Series)
		             */
					// series:boys
					else if(strToken.toLowerCase().indexOf("series:") == 0) {
						var strTokenEscaped = strToken.slice(7);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatched = matchRegex.test(this.containers[x].shows[y].showtitle);
					
						if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
							bMatchFound = true;
						}
					}

		            /**
		             * Subtitle (Episode)
		             */
					// episode:Rams
					else if(strToken.toLowerCase().indexOf("episode:") == 0) {
						var strTokenEscaped = strToken.slice(8);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatched = matchRegex.test(this.containers[x].shows[y].episodetitle);
					
						if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
							bMatchFound = true;
						}
					}

		            /**
		             * Description
		             */
					// desc:ooks
					else if(strToken.toLowerCase().indexOf("desc:") == 0) {
						var strTokenEscaped = strToken.slice(5);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatched = matchRegex.test(this.containers[x].shows[y].description);
					
						if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
							bMatchFound = true;
						}
					}

		            /**
		             * Director
		             */
					// director:Florent
					else if(strToken.toLowerCase().indexOf("director:") == 0) {
						var strTokenEscaped = strToken.slice(9);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatched = matchRegex.test(this.containers[x].shows[y].director);
					
						if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
							bMatchFound = true;
						}
					}

		            /**
		             * Actors
		             */
					// actor:willis
					else if(strToken.toLowerCase().indexOf("actor:") == 0) {
						var strTokenEscaped = strToken.slice(6);
		                var matchRegex = new RegExp(strTokenEscaped, "gim");
						var bRegexMatched = matchRegex.test(this.containers[x].shows[y].actors);
					
						if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
							bMatchFound = true;
						}
					}
				
		            /**
		             * Year (Matches)
		             */
					// year:2009
					else if(strToken.toLowerCase().indexOf("year:") == 0) {
						var strTokenEscaped = strToken.slice(5);
						var nYear = parseInt(this.containers[x].shows[y].year, 10);
						var nToken = parseInt(strTokenEscaped, 10);
					
						if((bNegative && (nYear != nToken)) || (!bNegative && (nYear == nToken))) {
							bMatchFound = true;
						}
					}
				
		            /**
		             * Year (After)
		             */
					// after:2009
					else if(strToken.toLowerCase().indexOf("after:") == 0) {
						var strTokenEscaped = strToken.slice(6);
						var nYear = parseInt(this.containers[x].shows[y].year, 10);
						var nToken = parseInt(strTokenEscaped, 10);
					
						if((bNegative && (nYear <= nToken)) || (!bNegative && (nYear > nToken))) {
							bMatchFound = true;
						}
					}

		            /**
		             * Year (Before)
		             */
					// before:2009
					else if(strToken.toLowerCase().indexOf("before:") == 0) {
						var strTokenEscaped = strToken.slice(7);
						var nYear = parseInt(this.containers[x].shows[y].year, 10);
						var nToken = parseInt(strTokenEscaped, 10);
					
						if((bNegative && (nYear >= nToken)) || (!bNegative && (nYear < nToken))) {
							bMatchFound = true;
						}
					}
				
		            /**
		             * Repeat
		             */
					// repeat:[yes|no|1|0]
					else if(strToken.toLowerCase().indexOf("repeat:") == 0) {
						var strTokenEscaped = strToken.slice(7);
						var bRepeat = parseInt(this.containers[x].shows[y].repeat,10)
						var bToken = false;
		                var yesRegex = new RegExp("yes|y|1", "gim");
		                var noRegex = new RegExp("no|n|0", "gim");
		                var bYes = yesRegex.test(strToken);
		                var bNo = noRegex.test(strToken);
					
						if((bNo && !bRepeat) || (bYes && bRepeat)) {
							bMatchFound = true;
						}
					}
				
					/**
					 * Token is not restricted could match anything
					 */
					else
					{
						var bTermFound=false;
						var bNegativeFailed=false;

			            /**
			             * Title
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].showtitle){
			                var matchRegex = new RegExp(strToken, "gim");
							var bRegexMatched = matchRegex.test(this.containers[x].shows[y].showtitle);
					
							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(bRegexMatched)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(bRegexMatched)
										bNegativeFailed = true;
								}
							}
						}
            
			            /**
			             * Subtitle (Episode)
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].episodetitle){
		                    var matchRegex = new RegExp(strToken, "gim");
							var bRegexMatched = matchRegex.test(this.containers[x].shows[y].episodetitle);
					
							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(bRegexMatched)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(bRegexMatched)
										bNegativeFailed = true;
								}
							}
			            }
            
			            /**
			             * Description
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].description){
		                    var matchRegex = new RegExp(strToken, "gim");
							var bRegexMatched = matchRegex.test(this.containers[x].shows[y].description);
					
							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(bRegexMatched)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(bRegexMatched)
										bNegativeFailed = true;
								}
							}
			            }
            
			            /**
			             * Director
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].director){
		                    var matchRegex = new RegExp(strToken, "gim");
							var bRegexMatched = matchRegex.test(this.containers[x].shows[y].director);
					
							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(bRegexMatched)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(bRegexMatched)
										bNegativeFailed = true;
								}
							}
			            }
            
			            /**
			             * Actors
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].actors){
		                    var matchRegex = new RegExp(strToken, "gim");
							var bRegexMatched = matchRegex.test(this.containers[x].shows[y].actors);
					
							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(bRegexMatched)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(bRegexMatched)
										bNegativeFailed = true;
								}
							}
			            }
		
			            /**
			             * Year (Matches)
			             */
			            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && this.containers[x].shows[y].year){
							var nYear = parseInt(this.containers[x].shows[y].year, 10);
							var nToken = parseInt(strToken, 10);

							/**
							 * 'Normal' term, may match this field
							 */
							if(!bNegative) {
								if(nYear == nToken)
									bTermFound = true;
							} 
						
							/**
							 * 'Negative' term. If it matched this field then check no more
							 */
							else {
								if(!bNegativeFailed){
									if(nYear != nToken)
										bNegativeFailed = true;
								}
							}
						}
						if(!bNegative)
							bMatchFound = bTermFound;
						else
							bMatchFound = !bNegativeFailed;
					}
					if(bMatchFound)
						nMatchingTokens++;
				}
	        }
            
			if(nMatchingTokens == tokenArrayLength) {
				this.containers[x].shows[y].container.style.display = "block";
				this.containers[x].shows[y].container.style.top = frameOffset + "px";
				frameOffset += 13;
				foundmatch = true;
				visibleshows++;
            } 
            else
				this.containers[x].shows[y].container.style.display = "none";
		}
		
		if(foundmatch){
			if(offset != 0)
				offset += 6;
			this.containers[x].header.style.top = offset + "px";
			offset += 18;
			offset += 6;
			this.containers[x].container.style.top = offset + "px";
			offset += frameOffset;
			this.containers[x].container.style.display = "block";
			this.containers[x].container.height = frameOffset + "px";
			this.containers[x].header.style.display = "block";
			visibledays++;
		} else {
			this.containers[x].container.style.display = "none";
			this.containers[x].header.style.display = "none";
		}
	}
	
	this.contentHeight = offset + 4;
	this.resize();
}

MyGuideUpcoming.prototype.fillData = function(){
	
}

MyGuideUpcoming.prototype.hide = function(){
	document.getElementById("myguideupcoming_container").style.display = "none";
}

MyGuideUpcoming.prototype.show = function(){
	if(this.contentArray.length == 0){
		document.getElementById("myguideupcoming_empty").style.display = "block";
	} else {
		document.getElementById("myguideupcoming_container").style.display = "block";
	}
}

MyGuideUpcoming.prototype.isEmpty = function(){
	if(this.contentArray.length == 0)
		return true;
	return false;
}

MyGuideUpcoming.prototype.sectionHeight = function(){
	if(this.contentArray.length == 0)
		return 147;
	
	var height = 0;
	if(this.height == 0){
		if(this.contentHeight >= 74){
			if(this.contentHeight > screen.availHeight - 50)
				return screen.availHeight - 50
			return this.contentHeight;
		}
		return 64;
	} else
		if(this.contentHeight > this.height)
			height = this.height;
		else
			height = this.contentHeight;
	if(height < 74)
		return 74;
	return height;
}

MyGuideUpcoming.prototype.animationHeight = function(){
	if(this.contentArray.length == 0)
		return 137;
	
	if(this.height == 0){
		if(this.contentHeight >= 74){
			if(this.contentHeight > screen.availHeight - 50)
				return screen.availHeight - 60
			return this.contentHeight - 10;
		}
		return 64;
	}
	
	if(this.contentHeight > this.height){
		if(this.height >= 74)
			return this.height - 10;
		return 64;
	} else {
		if(this.contentHeight >= 74)
			return this.contentHeight - 10;
		return 64;
	}
}

MyGuideUpcoming.prototype.buildDisplay = function(){
}

MyGuideUpcoming.prototype.updateDisplay = function(){
    DEBUGLOG("myguide.js[483]: MyGuideUpcoming.updateDisplay()");

	if(this.inSearch && this.searchString != null){
		mgu.doSearch();
		return;
	}
    
	while(document.getElementById("myguideupcoming_content_inner_container").hasChildNodes())
		document.getElementById("myguideupcoming_content_inner_container").removeChild(document.getElementById("myguideupcoming_content_inner_container").firstChild);

	if(this.contentArray.length == 0){
		if(initialSetupComplete && this.isSelected){
			document.getElementById("myguideupcoming_empty").style.opacity = 1;
			document.getElementById("myguideupcoming_empty").style.display = "block";
			document.getElementById("myguideupcoming_container").style.display = "none";
		} else {
			document.getElementById("myguideupcoming_container").style.display = "none";
		}
		return;	
	}

	if(document.getElementById("myguideupcoming_container").style.display != "block"){
		if(initialSetupComplete && this.isSelected){
			document.getElementById("myguideupcoming_container").style.display = "block";
			document.getElementById("myguideupcoming_container").style.opacity = 1;
			document.getElementById("myguideupcoming_empty").style.display = "none";
		} else {
			document.getElementById("myguideupcoming_empty").style.display = "none";
		}
	}
	
	var currentContainer = null;
	var offset = 0;
	var frameOffset = 0;
	var currentStartDate = null;
	var dateNow = new Date();
	this.containers.length = 0;
	
	var currentDayObjects = null;
	
	for(x=0;x<this.contentArray.length;x++){
        /**
         * Filter out items on hidden channels
         */
         if(this.contentArray[x]['channel_id'] && chm.isHidden(this.contentArray[x]['channel_id']))
            continue;

		var container = document.createElement("div");
		container.style.position = "absolute";
		container.style.top = (x * 13) + "px";
		container.style.height = "13px";
		container.style.width = "380px";
		document.getElementById("myguideupcoming_content_inner_container").appendChild(container);

		if(this.contentArray[x]['return_code']) continue;
		if(this.contentArray[x]['number_of_shows']) continue;

		var showDate = new Date();
		var showEndDate = new Date();

        var itemInfo = this.contentArray[x];
        
        var year	= parseInt(this.contentArray[x]['start_datetime'].substring(0,4),   10); 
        var month	= parseInt(this.contentArray[x]['start_datetime'].substring(4,6),   10);
        var day     = parseInt(this.contentArray[x]['start_datetime'].substring(6,8),  10);
        var hour	= parseInt(this.contentArray[x]['start_datetime'].substring(8,10), 10); 
        var minute	= parseInt(this.contentArray[x]['start_datetime'].substring(10,12), 10);
        var second	= parseInt(this.contentArray[x]['start_datetime'].substring(12,14), 10);
		
        showDate = new Date(year, month-1, day, hour, minute, second);
		
		var showDateString = showDate.getFullYear() + "/" + showDate.getMonth() + "/" + showDate.getDate();

		showEndDate = showDate;
		showEndDate.setTime(showEndDate.getTime() + (parseInt(this.contentArray[x]['duration'], 10) * 60 * 1000));
		
		if(showDate.getTime() < dateNow.getTime() && showEndDate.getTime() < dateNow.getTime())
			continue;
	
		if(showDateString != currentStartDate){
			currentStartDate = showDateString;

			if(currentContainer != null)
			{
				if(currentContainer != null)
					currentContainer.style.height = (parseInt(currentContainer.style.height, 10) + 10) + "px";
				offset += 6;
			}
			
			var header = document.createElement("div");
			header.style.backgroundImage = "url(images/lists/list_daydivider.png)"
			header.style.position = "absolute";
			header.style.width = "380px";
			header.style.height = "18px";
			header.style.top = offset + "px";
			document.getElementById("myguideupcoming_content_inner_container").appendChild(header);

			var monthNames = Array('January','February','March','April','May','June','July','August','September','October','November','December');
			var dayNames = Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');

			var daytitle = document.createElement("div")
			daytitle.innerHTML = dayNames[showDate.getDay()] + ", " + monthNames[showDate.getMonth()] + " " + showDate.getDate();
			daytitle.style.position = "absolute";
			daytitle.style.font = "bold 10px Lucida Grande"
			daytitle.style.textAlign = "center";
			daytitle.style.left = "10px";
			daytitle.style.top = "3px";
			daytitle.style.width = "360px";
			daytitle.style.color = "#B6BBC3";
			header.appendChild(daytitle);
			
			offset += 18;
			
			frameOffset = 6;
			currentContainer = document.createElement("div");
			currentContainer.style.position = "absolute";
			currentContainer.style.width = "380px";
			currentContainer.style.height = "0px";
			currentContainer.style.top = offset + "px";
			currentContainer.style.zIndex = 50;
			document.getElementById("myguideupcoming_content_inner_container").appendChild(currentContainer);

			offset += 6;
			
			currentDayObjects = new Array();
			
			var dayitem = {header:header, container:currentContainer, shows:currentDayObjects};
			this.containers.push(dayitem);
		}

		var header = document.createElement("div")
		header.style.width = "355px";
		header.style.position = "absolute";
		header.style.height = "13px";
		header.style.top = frameOffset + "px";
		header.setAttribute("onclick", "sht.fillEpgSheetDetails('" + this.contentArray[x]["show_id"] +"', 1, false, false);");
		currentContainer.style.height = (parseInt(currentContainer.style.height, 10) + 13) + "px";
		currentContainer.appendChild(header);
		offset += 13;
		frameOffset += 13;

		var time = document.createElement("div");
		time.style.font = "bold 10px Lucida Grande"
		time.style.textAlign = "right";
		time.style.position = "absolute";
		time.style.left = "7px";
		time.style.width = "45px";
		time.style.color = "#B6BBC3";
		header.appendChild(time);
	
        var year	= parseInt(this.contentArray[x]['start_datetime'].substring(0,4),   10); 
        var month	= parseInt(this.contentArray[x]['start_datetime'].substring(4,6),   10);
        var day     = parseInt(this.contentArray[x]['start_datetime'].substring(6,8),  10);
        var hour	= parseInt(this.contentArray[x]['start_datetime'].substring(8,10), 10); 
        var minute	= parseInt(this.contentArray[x]['start_datetime'].substring(10,12), 10);
        var second	= parseInt(this.contentArray[x]['start_datetime'].substring(12,14), 10);
		
        var showDate = new Date(year, month-1, day, hour, minute, second);
		
		if(epg.timeFormat == 24){
			var minutes = showDate.getMinutes();
			if(minutes < 10)
				minutes = "0" + minutes;
				
			var hours = showDate.getHours();
			if(hours < 10)
				hours = "0" + hours;

			time.innerHTML = hours + ':' + minutes;
		} else {
			if(showDate.getHours() >= 12)
				suffix = "pm"
			else
				suffix = "am"
			
			var hours = showDate.getHours();
			if(hours == 0)
				hours = 12;
			else if(hours > 12)
				hours -= 12;

			var minutes = showDate.getMinutes();
			if(minutes < 10)
				minutes = "0" + minutes;
			time.innerHTML = hours + ':' + minutes + suffix;
		}
		
		var iconSize = 0;
		
		if(this.contentArray[x]['is_scheduled'] == "1"){
			if(this.contentArray[x]['part_of_series'] == "1"){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.setAttribute("valign", "middle");
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 18
			} else {
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_rec.png";
				statusImage.width = 8;
				statusImage.height = 12;
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
			}

            if(this.contentArray[x]['is_keyword'] == "1" && this.contentArray[x]['view_or_record'] == "1") {
				var statusImage = document.createElement("img");
                statusImage.src = "images/remoteicons/remote_smartrec.png";
                statusImage.width = 8;
                statusImage.height = 12;
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
            }
		} else {
			if(this.contentArray[x]['part_of_series'] == "1"){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries_cancel.png";
				statusImage.width = 14;
				statusImage.height = 12;
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 18
			}
		}

		if(this.contentArray[x]['is_favorite'] == "1") {
            var statusImage = document.createElement("img");
            statusImage.src = "images/remoteicons/remote_favourite.png";
            statusImage.width = 14;
            statusImage.height = 12;
            statusImage.style.left = (63 + iconSize) + "px";
            statusImage.style.top = (2) + "px";
            statusImage.style.position = "absolute";
            iconSize += 18;
            header.appendChild(statusImage);
		}


        if(this.contentArray[x]['is_keyword'] == "1" && this.contentArray[x]['view_or_record'] == "0") {
            var statusImage = document.createElement("img");
            statusImage.src = "images/remoteicons/remote_smartfavourite.png";
            statusImage.width = 8;
            statusImage.height = 12;
            statusImage.style.left = (63 + iconSize) + "px";
            statusImage.style.top = (2) + "px";
            statusImage.style.position = "absolute";
            iconSize += 12;
            header.appendChild(statusImage);
        }

		if(this.contentArray[x]['is_recommended'] == "1" && (this.contentArray[x]['is_favorite'] != "1" && this.contentArray[x]['is_scheduled'] != "1")) {
			var statusImage = document.createElement("img");
			statusImage.src = "images/remoteicons/remote_recommended.png";
			statusImage.width = 8;
			statusImage.height = 12;
			statusImage.style.left = (63 + iconSize) + "px";
			statusImage.style.top = (2) + "px";
			statusImage.style.position = "absolute";
			iconSize += 12;
			header.appendChild(statusImage);
		}
		if(iconSize > 0)
			iconSize += 1;


		var channel = document.createElement("div");
		channel.setAttribute("class", "ellipsis");
		channel.innerHTML = this.contentArray[x]["channel_name_short"];
		channel.style.font = "bold 10px Lucida Grande, Tahoma Bold"
		channel.style.textAlign = "right";
		channel.style.position = "absolute";
		channel.style.left = "291px";
		channel.style.width = "60px"
		channel.style.color = "#B6BBC3";
		header.appendChild(channel);

		//var maxTitleWidth = 280 - channel.width - iconSize - 10;;

		var shownameContainer = document.createElement("div");
		shownameContainer.setAttribute("class", "ellipsis");
		shownameContainer.style.font = "bold 10px Lucida Grande"
		shownameContainer.style.position = "absolute";
		shownameContainer.style.textAlign = "left";
		shownameContainer.style.left = (63 + iconSize) + "px";
		shownameContainer.style.color = "#ffffff";
		shownameContainer.style.width = (286 - iconSize - 63) + "px"
		header.appendChild(shownameContainer);

		var showname = document.createElement("span");
		shownameContainer.appendChild(showname);
		showname.innerHTML = this.contentArray[x]["series_name"];
		if(this.contentArray[x]['year'] && this.contentArray[x]['year'].length == 4)
			showname.innerHTML += " (" + this.contentArray[x]['year'] + ")";

		
		if(this.contentArray[x]["episode_name"] && this.contentArray[x]["episode_name"].length > 0) { 
			var episode = document.createElement("span");
			episode.innerHTML = " '" + this.contentArray[x]["episode_name"] + "'";
			episode.style.color = "#6ED8F8";
			shownameContainer.appendChild(episode);
		}
		if(!this.contentArray[x]['actors'])
			this.contentArray[x]['actors'] = "";
		if(!this.contentArray[x]['director'])
			this.contentArray[x]['director'] = "";
		if(!this.contentArray[x]['description'])
			this.contentArray[x]['description'] = "";
		if(!this.contentArray[x]['episode_name'])
			this.contentArray[x]['episode_name'] = "";
		var showitem = {showtitle:this.contentArray[x]['series_name'], episodetitle:this.contentArray[x]['episode_name'], description:this.contentArray[x]['description'], actors:this.contentArray[x]['actors'], director:this.contentArray[x]['director'],container:header};
		currentDayObjects.push(showitem);
	}
	offset += 4
	this.contentHeight = offset;
}

MyGuideUpcoming.prototype.resize = function(){
	var height = this.sectionHeight();

	document.getElementById("myguideupcoming_container").style.height = (height - 3) + "px";
	document.getElementById("myguideupcoming_content_inner_container").style.height = (this.contentHeight) + "px"
	document.getElementById("myguideupcoming_content_container").style.height = height + "px";
	document.getElementById("myguideupcoming_resize_control").style.top = (height - 15) + "px";
	document.getElementById("myguideupcoming_scroller").style.height = (height - 21) + "px";
	
	if(this.isSelected){
		resizeFront(72 + (height - 2) + 35)
		document.getElementById("main_container").style.height = (height - 10) + "px";
		document.getElementById("main_base").style.top = (72 + (height - 10)) + "px";
	}
	myguideScrollArea.refresh();
	myguideScroller.refresh();
}

function doresizeMyGuideUpcoming(event){
  	mgu.doresize(event);
}

function endresizeMyGuideUpcoming(event) {
  	mgu.endresize();
}

MyGuideUpcoming.prototype.beginresize = function(event){
	this.resizeorigin = event.y;
	this.resizestart = this.sectionHeight();
	document.addEventListener("mousemove",doresizeMyGuideUpcoming, false);
	document.addEventListener("mouseup", endresizeMyGuideUpcoming, false);
}

MyGuideUpcoming.prototype.doresize = function(event){
	newheight =  event.y - this.resizeorigin;
	this.height = this.resizestart + newheight;
	if(this.height < 74)
		this.height = 74;

	if((this.height) > this.contentHeight)
		this.height = this.contentHeight;
	this.resize();
}

MyGuideUpcoming.prototype.endresize = function(){
	document.removeEventListener("mousemove",doresizeMyGuideUpcoming, false);
	document.removeEventListener("mouseup", endresizeMyGuideUpcoming, false);
	savePref(this.height, "myGuideUpcomingScrollPoint");
}

MyGuideUpcoming.prototype.resetHeight = function(){
	this.height = 0;
	savePref("0", "myGuideUpcomingScrollPoint");
	this.isSelected = false;
	oldHeight = parseInt(document.getElementById("myguideupcoming_container").style.height, 10);
	this.resize();
	this.isSelected = true;
	resizeFromHeightReset(oldHeight, document.getElementById("myguideupcoming_container"));
}

MyGuideUpcoming.prototype.downloaderCallback = function(json){
	this.parseData(json);
	this.updateDisplay();
	
    DEBUGLOG("myguide.js[865]: this.inSearch: " + this.inSearch + "    this.searchString: " + this.searchString);
	if(this.inSearch && this.searchString != null){
		mgu.doSearch();
		return;
	}
	
	this.resize();
	upcomingRecordDataUpdated();
}

MyGuideUpcoming.prototype.parseData = function(json){
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
	/**
	 * Put response into a temp array in case it fails
	 */
    DEBUGLOG("myguide.js[606]: json: " + json);
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	/**
	 * Copy & split temp array into Header & Data
	 */
	this.dlHeader = tempArray.shift();
    DEBUGLOG("myguide.js[614]: return_code: " + this.dlHeader["return_code"]);
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
    if(this.dlHeader['return_code'] == "10") {
        ath.expire();
        return;
    } else if(this.dlHeader['return_code'] == "55") {
        ath.subExpired();
        return;
    }
	this.contentArray.length = 0;
	this.contentArray = this.contentArray.concat(tempArray);
}

MyGuideUpcoming.prototype.updateData = function(userInitiated){
	DEBUGLOG("myguide.js[904]: MyGuideUpcoming.updateData(" + userInitiated + ")");

	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
		DEBUGLOG("data.js[578]: Auto fetch and last fetch within minimum hit time.");
		return;
	}
	
	mguDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kMGUFeed);
	mguDownloader.fetchURL();
}	


MyGuideUpcoming.prototype.recordForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}

MyGuideUpcoming.prototype.recordForShowID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['show_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}