function MyGuideSeries(){
	this.isSelected = false;
	this.contentHeight = 0;
	this.height = parseInt(loadPref("myGuideSeriesScrollPoint"), 10);	

	this.resizeorigin = 0;
	resizestart = 0;
	
	this.contentArray = new Array();
	this.mergedContent = new Array();
	
	this.containers = new Array();

	this.inSearch = false;
	this.searchString = null;
	this.usingRestoredSearch = false;
	this.recentSearches = Array();
	this.recentSearchesMenu = Array();
	
	this.dlHeader = new Object();
}

MyGuideSeries.prototype.clear = function(){
	while(document.getElementById("myguideseries_content_inner_container").hasChildNodes())
		document.getElementById("myguideseries_content_inner_container").removeChild(document.getElementById("myguideseries_content_inner_container").firstChild);
		
	this.contentArray.length = 0;
	this.mergedContent.length = 0;
	this.containers.length = 0;
	this.inSearch = false;
	this.searchString = null;
	this.contentHeight = 0;
	this.isSelected = false;
}

MyGuideSeries.prototype.setup = function(){
	var _self = this;
	document.getElementById("myguideseries_resize_control").onmousedown = function(event){ _self.beginresize(event); }
	document.getElementById("my-guide-series-controls-search").onsearch = function(){ _self.searchPrelim(); };
	document.getElementById("myguideseries_resize_control").ondblclick = function(event){ _self.resetHeight(); }
}

MyGuideSeries.prototype.searchPrelim = function(){
	if(this.searchtimer != null){
		clearInterval(this.searchtimer);
	}
	this.searchtimer = null;

	var _self = this;
	this.searchtimer = setInterval(function(){ _self.doSearch(); }, 600);
}

MyGuideSeries.prototype.doSearch = function(){
	sht.forceCloseSheets();
	if(this.searchtimer)
		clearInterval(this.searchtimer)
	this.searchtimer = null;
	
	if(document.getElementById("my-guide-series-controls-search").value.length == 0){
		this.inSearch = false;
		this.searchString = null;
		this.resetDisplay();
	} else {
		if(this.inSearch == false)
			this.inSearch = true;
	
		this.searchString = document.getElementById("my-guide-series-controls-search").value;
		this.filterWithString(this.searchString)
	}
}

MyGuideSeries.prototype.resetDisplay = function(searchstring){
	var offset = 0;
	var visibledays = 0;
	var visibleshows = 0;
		
	for(x=0;x<this.containers.length;x++){
		this.containers[x].container.style.top = (x * 13) + "px";
		this.containers[x].container.style.display = "block";
	}
	this.contentHeight = (this.containers.length * 13) + 2;
	this.resize();
}

MyGuideSeries.prototype.filterWithString = function(searchstring){
	var visibleshows = 0;

    var tokenArray = smartSplit( " ", searchstring, false, "\"", true );
    var tokenArrayLength = tokenArray.length;

	for(x=0;x<this.containers.length;x++){
        var itemInfo = this.containers[x];

        var found=false;
		var bNegative;
		var strToken;
		var nMatchingTokens=0;

		for(var i=0;i<tokenArrayLength;i++){
			strToken = tokenArray[i];
			bNegative = (strToken[0] == '-');
			var bMatchFound=false;

			// Starts with a -, strip it, we have flagged it as a -ve term
			if(bNegative)
				strToken = strToken.slice(1);

            // If the token is one of our reserved words and there is nothing after the ':'
            // then remove the ':' so it acts like a normal word. ie treat 'genre:' as 'genre'
            // but once you type 'genre:foo' then do a genre search for 'foo'
            if(strToken.toLowerCase() == "title:" 		||
               strToken.toLowerCase() == "series:" 		||
               strToken.toLowerCase() == "episode:" 	||
               strToken.toLowerCase() == "desc:" 		||
               strToken.toLowerCase() == "genre:" 		||
               strToken.toLowerCase() == "actor:" 		||
               strToken.toLowerCase() == "director:" 	||
               strToken.toLowerCase() == "repeat:" 		||
               strToken.toLowerCase() == "year:" 		||
               strToken.toLowerCase() == "after:" 		||
               strToken.toLowerCase() == "before:") {
                strToken = strToken.slice(0,strToken.length -1);
            }
            
            /**
             * Title
             */
			// title:boys
			if(strToken.toLowerCase().indexOf("title:") == 0) {
				var strTokenEscaped = strToken.slice(6);
                var matchRegex = new RegExp(strTokenEscaped, "gim");
				var bRegexMatched;
				/**
				 * NOTE: The keywordpattern is only filled in for keyword recordings while showtitle is filled
				 *       in for both so we must do the tests in this order, keyword and the showtitle
				 */
				if(itemInfo.keywordpattern && itemInfo.keywordpattern.length > 0)
					bRegexMatched=matchRegex.test(itemInfo.keywordpattern);
				else if(itemInfo.showtitle && itemInfo.showtitle.length > 0)
					bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
				if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
					bMatchFound = true;
				}
			}
            /**
             * Title (Series)
             */
			// series:boys
			else if(strToken.toLowerCase().indexOf("series:") == 0) {
				var strTokenEscaped = strToken.slice(7);
                var matchRegex = new RegExp(strTokenEscaped, "gim");
				var bRegexMatched;
				/**
				 * NOTE: The keywordpattern is only filled in for keyword recordings while showtitle is filled
				 *       in for both so we must do the tests in this order, keyword and the showtitle
				 */
				if(itemInfo.keywordpattern && itemInfo.keywordpattern.length > 0)
					bRegexMatched=matchRegex.test(itemInfo.keywordpattern);
				else if(itemInfo.showtitle && itemInfo.showtitle.length > 0)
					bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
				if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
					bMatchFound = true;
				}
			}
			/**
			 * Token is not restricted could match anything
			 */
			else
			{
				var bTermFound=false;
				var bNegativeFailed=false;

	            /**
	             * Title
	             */
	            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && (itemInfo.showtitle || itemInfo.keywordpattern)){
	                var matchRegex = new RegExp(strToken, "gim");
					var bRegexMatched;
					/**
					 * NOTE: The keywordpattern is only filled in for keyword recordings while showtitle is filled
					 *       in for both so we must do the tests in this order, keyword and the showtitle
					 */
					if(itemInfo.keywordpattern && itemInfo.keywordpattern.length > 0)
						bRegexMatched=matchRegex.test(itemInfo.keywordpattern);
					else if(itemInfo.showtitle && itemInfo.showtitle.length > 0)
						bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
					/**
					 * 'Normal' term, may match this field
					 */
					if(!bNegative) {
						if(bRegexMatched)
							bTermFound = true;
					} 
					
					/**
					 * 'Negative' term. If it matched this field then check no more
					 */
					else {
						if(!bNegativeFailed){
							if(bRegexMatched)
								bNegativeFailed = true;
						}
					}
				}

				if(!bNegative)
					bMatchFound = bTermFound;
				else
					bMatchFound = !bNegativeFailed;
			}
			if(bMatchFound)
				nMatchingTokens++;
		}
                
   		if(nMatchingTokens == tokenArrayLength){
			itemInfo.container.style.top = (visibleshows * 13) + "px";
			itemInfo.container.style.display = "block";
			visibleshows++;
        } 
        else
			itemInfo.container.style.display = "none";
	}
	
	this.contentHeight = (visibleshows * 13) + 2;
	this.resize();
}


MyGuideSeries.prototype.fillData = function(){
	
}

MyGuideSeries.prototype.hide = function(){
	document.getElementById("myguideseries_container").style.display = "none";
}

MyGuideSeries.prototype.show = function(){
	if(this.mergedContent.length == 0){
		document.getElementById("myguideseries_empty").style.display = "block";
	} else {
		document.getElementById("myguideseries_container").style.display = "block"
	}
}

MyGuideSeries.prototype.isEmpty = function(){
	if(this.mergedContent.length == 0)
		return true;
	return false;
}

MyGuideSeries.prototype.sectionHeight = function(){
	if(this.mergedContent.length == 0)
		return 129;
	
	var height = 0;
	if(this.height == 0)
		height = this.contentHeight;
	else
		if(this.contentHeight > this.height)
			height = this.height;
		else
			height = this.contentHeight;
	if(height < 74)
		return 74;
	if(height > screen.availHeight - 50)
		return screen.availHeight - 50
	return height;
}

MyGuideSeries.prototype.animationHeight = function(){
	if(this.mergedContent.length == 0)
		return 125;
	
	if(this.height == 0){
		if(this.contentHeight >= 74){
			if(this.contentHeight > screen.availHeight - 50)
				return screen.availHeight - 54
			return this.contentHeight - 4;
		}
		return 70;
	}
	
	if(this.contentHeight > this.height){
		if(this.height >= 74)
			return this.height - 4;
		return 70;
	} else {
		if(this.contentHeight >= 74)
			return this.contentHeight - 4;
		return 70;
	}
}

MyGuideSeries.prototype.buildDisplay = function(){
}

MyGuideSeries.prototype.updateDisplay = function(){
	if(this.inSearch && this.searchString != null){
		mgs.doSearch();
		return;
	}

	this.containers.length = 0;
	
	while(document.getElementById("myguideseries_content_inner_container").hasChildNodes())
		document.getElementById("myguideseries_content_inner_container").removeChild(document.getElementById("myguideseries_content_inner_container").firstChild);

	if(this.mergedContent.length == 0){
		if(initialSetupComplete && this.isSelected){
			document.getElementById("myguideseries_empty").style.display = "block";
			document.getElementById("myguideseries_empty").style.opacity = 1;
			document.getElementById("myguideseries_container").style.display = "none";
		} else {
			document.getElementById("myguideseries_container").style.display = "none";
		}
		return;	
	}
	
	if(document.getElementById("myguideseries_container").style.display != "block"){
		if(initialSetupComplete && this.isSelected){
			document.getElementById("myguideseries_container").style.display = "block";
			document.getElementById("myguideseries_container").style.opacity = 1;
			document.getElementById("myguideseries_empty").style.display = "none";
		} else {
			document.getElementById("myguideseries_empty").style.display = "none";
		}
	}

    /**
     * There are several possibilities to consider here
     *
     * Keyword Fav
     * Keyword Record
     * Series Recording
     * Series Recording + Fav
     * Fav
     */

	for(x=0;x<this.mergedContent.length;x++){
        var itemInfo = this.mergedContent[x];
		var header = document.createElement("div");;
		var lineText;
        
		var iconSize = 0;

//        if(itemInfo['keyword_recording_id']) {
//            DEBUGLOG("myguideseries.js[217]: Keyword: M: " + itemInfo['match_pattern'] + "  A: " + itemInfo['avoid_pattern'] + "  V/R: " + itemInfo['view_or_record']);
//        }
//        else if(itemInfo['series_recording_id'] == "-1") {
//            DEBUGLOG("myguideseries.js[220]: S: " + itemInfo['series_name'] + "  F: " + itemInfo['is_favorite']);
//        } else {
//            DEBUGLOG("myguideseries.js[222]: ID: " + itemInfo['series_recording_id'] + "  S: " + itemInfo['series_name'] + "  F: " + itemInfo['is_favorite']);
//        }

        /**
         * Is this a keyword recording or favourite
         */
         if(itemInfo['keyword_recording_id']){
            header.style.width = "355px";
            header.style.height = "13px";
            header.style.top = (x * 13) + "px";
            header.style.position = "absolute";
            header.setAttribute("onclick", "sht.fillEpgSheetDetails('" + itemInfo["keyword_recording_id"] +"', 5, false, false);");
            document.getElementById("myguideseries_content_inner_container").appendChild(header);

            if(itemInfo['view_or_record'] == "1"){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_smartrec.png";
				statusImage.width = 8;
				statusImage.height = 12;
				statusImage.setAttribute("valign", "middle");
				header.appendChild(statusImage);
				statusImage.style.left = (12 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
                lineText = "Keyword Record for <span class=\"episode-text\">'" + itemInfo["match_pattern"];
                if(this.mergedContent[x]["avoid_pattern"]){
                    var avoidArray = smartSplit( " ", itemInfo["avoid_pattern"], false, '"', false);
                    lineText += " -" + avoidArray.join(" -");
                }
                lineText += "'</span>";
            } else {
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_smartfavourite.png";
				statusImage.width = 8;
				statusImage.height = 12;
				statusImage.setAttribute("valign", "middle");
				header.appendChild(statusImage);
				statusImage.style.left = (12 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
                lineText = "Keyword Favourite for <span class=\"episode-text\">'" + itemInfo["match_pattern"];
                if(this.mergedContent[x]["avoid_pattern"]){
                    var avoidArray = smartSplit( " ", itemInfo["avoid_pattern"], false, '"', false);
                    lineText += "-" + avoidArray.join(" -");
                }
                lineText += "'</span>";
            }
         }
        /**
         * Check if the program is part of a series recording or just a single recording.
         */
         else if(itemInfo['series_recording_id']	!= "-1"){
                header.style.width = "355px";
                header.style.height = "13px";
                header.style.top = (x * 13) + "px";
                header.style.position = "absolute";
                header.setAttribute("onclick", "sht.fillEpgSheetDetails('" + itemInfo["series_recording_id"] +"', 3, false, false);");
                document.getElementById("myguideseries_content_inner_container").appendChild(header);

				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.setAttribute("valign", "middle");
				header.appendChild(statusImage);
				statusImage.style.left = (12 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 18
                lineText = this.mergedContent[x]["series_name"];
		} else {
                header.style.width = "355px";
                header.style.height = "13px";
                header.style.top = (x * 13) + "px";
                header.style.position = "absolute";
                header.setAttribute("onclick", "sht.fillEpgSheetDetails('" + itemInfo["series_id"] +"', 3, false, true);");
                document.getElementById("myguideseries_content_inner_container").appendChild(header);

                lineText = itemInfo["series_name"];
        }

		/**
		 * The favourite pill is independent of the single/series recording pill
		 */
		if(itemInfo['is_favorite'] == "1") {
			var statusImage = document.createElement("img");
			statusImage.src = "images/remoteicons/remote_favourite.png";
			statusImage.width = 14;
			statusImage.height = 12;
			statusImage.style.left = (12 + iconSize) + "px";
			statusImage.style.top = (2) + "px";
			statusImage.style.position = "absolute";
			iconSize += 18;
			header.appendChild(statusImage);
		}
						
		if(iconSize > 0)
			iconSize += 1;
			
		var deviceWidth = 0;	

		if(itemInfo['series_recording_id']	!= "-1" || (itemInfo['keyword_recording_id'] && itemInfo['view_or_record'] == "1")){
			var device = document.createElement("div");
			device.innerHTML = this.mergedContent[x]["device_label"];
			device.style.font = "bold 10px Lucida Grande"
			device.setAttribute("class", "ellipsis");
			device.style.position = "absolute";
			device.style.textAlign = "right";
			device.style.left = "278px";
			device.style.color = "#B6BBC3";
			device.style.width = "75px"
			header.appendChild(device);
			
			deviceWidth = 75;
		}

        /**
         * Setup "Show Name" container, this could contain the details of a keyword search if applicable
         */
		var shownameContainer = document.createElement("div");
		shownameContainer.setAttribute("class", "ellipsis");
		shownameContainer.setAttribute("class", "ellipsis");
		shownameContainer.style.font = "bold 10px Lucida Grande"
		shownameContainer.style.position = "absolute";
		shownameContainer.style.textAlign = "left";
		shownameContainer.style.left = (12 + iconSize) + "px";
		shownameContainer.style.color = "#ffffff";
		shownameContainer.style.width = (340 - iconSize - deviceWidth) + "px"
        shownameContainer.innerHTML = lineText;

		if(itemInfo['year'] && itemInfo['year'].length == 4)
			shownameContainer.innerHTML += " (" + this.mergedContent[x]['year'] + ")";
		header.appendChild(shownameContainer);

//        DEBUGLOG("myguideseries.js[358]: showtitle: " + lineText + "  description: " + this.mergedContent[x]["series_description"]);
		var item = {container:header, showtitle:lineText, description:this.mergedContent[x]["series_description"]};
		this.containers.push(item);
	}
	this.contentHeight = (x * 13) + 2;
}

MyGuideSeries.prototype.resize = function(){
	var height = this.sectionHeight();
	
	document.getElementById("myguideseries_container").style.height = (height - 3) + "px";
	document.getElementById("myguideseries_content_inner_container").style.height = this.contentHeight + "px"
	document.getElementById("myguideseries_content_container").style.height = height + "px";
	document.getElementById("myguideseries_resize_control").style.top = (height - 15) + "px";
	document.getElementById("myguideseries_scroller").style.height = (height - 15) + "px";
	
	if(this.isSelected){
		resizeFront(72 + (height - 2) + 35)
		document.getElementById("main_container").style.height = (height - 4) + "px";
		document.getElementById("main_base").style.top = (72 + (height - 4)) + "px";
	}
	myguideSeriesScroller.refresh();
	myguideSeriesScrollArea.refresh();
}

function doresizeMyGuideSeries(event){
  	mgs.doresize(event);
}

function endresizeMyGuideSeries(event) {
  	mgs.endresize();
}


MyGuideSeries.prototype.beginresize = function(event){
	this.resizeorigin = event.y;
	this.resizestart = this.sectionHeight();
	document.addEventListener("mousemove",doresizeMyGuideSeries, false);
	document.addEventListener("mouseup", endresizeMyGuideSeries, false);
}

MyGuideSeries.prototype.doresize = function(){
	newheight =  event.y - this.resizeorigin;
	this.height = this.resizestart + newheight;
	if(this.height < 74)
		this.height = 74;

	if((this.height) > this.contentHeight)
		this.height = this.contentHeight;

	this.resize();
}

MyGuideSeries.prototype.endresize = function(){
	document.removeEventListener("mousemove",doresizeMyGuideSeries, false);
	document.removeEventListener("mouseup", endresizeMyGuideSeries, false);
	savePref(this.height, "myGuideSeriesScrollPoint");
}

MyGuideSeries.prototype.resetHeight = function(){
	this.height = 0;
	savePref("0", "myGuideSeriesScrollPoint");
	this.isSelected = false;
	oldHeight = parseInt(document.getElementById("myguideseries_container").style.height, 10);
	this.resize();
	this.isSelected = true;
	resizeFromHeightReset(oldHeight, document.getElementById("myguideseries_container"));
}


MyGuideSeries.prototype.mergeData = function(){
	var favs = fav.contentArray;
	var keys = key.contentArray;
	this.mergedContent.length = 0;

	for(var i=0;i<this.contentArray.length;i++){
		var myGuideSeriesRec = new Object();
		seriesRecordingRec = this.contentArray[i];

		myGuideSeriesRec['series_recording_id'] = seriesRecordingRec['series_recording_id'];
		myGuideSeriesRec['series_id'] 			= seriesRecordingRec['series_id'];
		myGuideSeriesRec['series_description']	= seriesRecordingRec['series_description'];
		myGuideSeriesRec['series_name']			= seriesRecordingRec['series_name'];
		myGuideSeriesRec['device_id'] 			= seriesRecordingRec['device_id'];
		myGuideSeriesRec['device_label'] 		= seriesRecordingRec['device_label'];
		myGuideSeriesRec['start_minutes'] 		= seriesRecordingRec['start_minutes'];
		myGuideSeriesRec['channel_id'] 			= seriesRecordingRec['channel_id'];
		myGuideSeriesRec['first_runs_only'] 	= seriesRecordingRec['first_runs_only'];
		myGuideSeriesRec['is_favorite']			= "0";
        myGuideSeriesRec['year']                = seriesRecordingRec['year'];
		this.mergedContent.push(myGuideSeriesRec);
	}
	
	for(var i=0;i<favs.length;i++){
		var myGuideSeriesRecID = this.mergedRecordIndexForName(favs[i]['series_name']);
		if(myGuideSeriesRecID >= 0){
            for(var j=0;j<this.mergedContent.length;j++){
                var seriesRec = this.mergedContent[j];
                if(seriesRec['series_name'] == favs[i]['series_name'])
                    seriesRec['is_favorite'] = "1"; 
            }
		} else {
			var myGuideSeriesRec = new Object();
			favoriteRec = favs[i];
			myGuideSeriesRec['series_recording_id'] = -1;
			myGuideSeriesRec['series_id'] 			= favoriteRec['series_id'];
			myGuideSeriesRec['year']                = favoriteRec['year'];
			myGuideSeriesRec['series_name']			= favoriteRec['series_name'];
			myGuideSeriesRec['series_description']	= favoriteRec['series_description'];
			myGuideSeriesRec['device_id'] 			= -1;
			myGuideSeriesRec['device_label'] 		= '';
			myGuideSeriesRec['start_minutes'] 		= -1;
			myGuideSeriesRec['channel_id'] 			= -1;
			myGuideSeriesRec['first_runs_only'] 	= -1;
			myGuideSeriesRec['is_favorite']			= "1";
			this.mergedContent.push(myGuideSeriesRec);
		}
	}

	for(var i=0;i<keys.length;i++){
        var myGuideSeriesRec = new Object();
        keywordRec = keys[i];
        myGuideSeriesRec['series_recording_id'] = -1;
        myGuideSeriesRec['keyword_recording_id'] = keywordRec['keyword_recording_id'];
        myGuideSeriesRec['series_id'] 			= '';
        myGuideSeriesRec['year']                = '';
        myGuideSeriesRec['series_name']			= '';
        myGuideSeriesRec['match_pattern']		= keywordRec['match_pattern'];
        myGuideSeriesRec['avoid_pattern']		= keywordRec['avoid_pattern'];
        myGuideSeriesRec['view_or_record']		= keywordRec['view_or_record'];
        myGuideSeriesRec['series_description']	= '';
        myGuideSeriesRec['device_id'] 			= -1;
        myGuideSeriesRec['device_label'] 		= keywordRec['device_label'];
        myGuideSeriesRec['start_minutes'] 		= -1;
        myGuideSeriesRec['channel_id'] 			= -1;
        myGuideSeriesRec['first_runs_only'] 	= -1;
        myGuideSeriesRec['is_keyword']			= "1";
        this.mergedContent.push(myGuideSeriesRec);
	}

	this.mergedContent.sort(sortMyGuideSeries);
}

function sortMyGuideSeries(a,b){
	var aName = a['series_name'];
	var bName = b['series_name'];
    return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
}


MyGuideSeries.prototype.downloaderCallback = function(json){
	this.parseData(json);
	this.mergeData();
	this.updateDisplay();
	
	if(this.inSearch && this.searchString != null){
		mgs.doSearch();
		return;
	}
	
	this.resize();
	seriesRecordDataUpdated();
    keywordRecordDataUpdated();
}

MyGuideSeries.prototype.parseData = function(json){
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
    DEBUGLOG("myguideseries.js[592]: json: " + json);
    
	/**
	 * Put response into a temp array in case it fails
	 */
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	/**
	 * Copy & split temp array into Header & Data
	 */
	this.dlHeader = tempArray.shift();
    DEBUGLOG("myguideseries.js[526]: return_code: " + this.dlHeader["return_code"]);
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
    if(this.dlHeader['return_code'] == "10") {
        ath.expire();
        return;
    } else if(this.dlHeader['return_code'] == "55") {
        ath.subExpired();
        return;
    }
	this.contentArray.length = 0;
	this.contentArray = this.contentArray.concat(tempArray);
//    this.contentArray = tempArray;
}

MyGuideSeries.prototype.updateData = function(userInitiated){
	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
//		DEBUGLOG("data.js[578]: Auto fetch and last fetch within minimum hit time.");
		return;
	}
	
	mgsDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kMGSFeed);
	mgsDownloader.fetchURL();
}	

MyGuideSeries.prototype.recordForName = function(seriesName){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_name'] == seriesName)
			return this.contentArray[i];
	
	return null;
}

MyGuideSeries.prototype.mergedRecordIndexForName = function(seriesName){
	var popularArrayLength = this.mergedContent.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.mergedContent[i]['series_name'] == seriesName)
			return i;
	
	return -1;
}

MyGuideSeries.prototype.recordForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}

MyGuideSeries.prototype.recordForSeriesRecordingID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_recording_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}


MyGuideSeries.prototype.mergedRecordForID = function(seriesID){
	var popularArrayLength = this.mergedContent.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.mergedContent[i]['series_id'] == seriesID)
			return this.mergedContent[i];
	
	return null;
}